<?PHP
sapp_include_once('common.php');

function form_handler() {

	$valid_required = true;
	$valid_optional = true;

	/*******************************
	 *
	 *	Required parameters
	 *
	 *******************************/

	// check install_prefix separately, as it requires special validity check
	$install_prefix = sapp_get_submit_value('install_prefix');
	if (null === $install_prefix) {
		sapp_set_warning(msg('you_should_specify_installation_directory'));
		sapp_set_wrong('install_prefix');
	} elseif (SITEAPP_DIR_NOT_EXISTS !== ($ret = sapp_set_install_prefix($install_prefix))) {

		sapp_set_wrong('install_prefix');

		switch ($ret) {

			case SITEAPP_DIR_INVALID_NAME:
				sapp_set_warning(msg('installation_directory_name_isn_t_valid'));
				break;

			case SITEAPP_DIR_USED_BY_UNKNOWN:
				sapp_set_warning(msg('installation_directory_already_exists'));
				break;

			case SITEAPP_DIR_USED_BY_SITEAPP:
				sapp_set_warning(msg('installation_directory_is_used_by_other_site_application'));
				break;
		}
	}

	if (sapp_is_ssl_avaible())
		$valid_required &= check_and_set_required('ssl_target_directory');

	$valid_required &= check_and_set_required('bbc_mainsite',		'check_url');
	$valid_required &= check_and_set_required('bbc_titlebar');
	$valid_required &= check_and_set_required('bbc_language');
	$valid_required &= check_and_set_required('bbc_maxtime',		'check_int');
	$valid_required &= check_and_set_required('bbc_maxvisible',		'check_int');
	$valid_required &= check_and_set_required('bbc_maxos',			'check_int');
	$valid_required &= check_and_set_required('bbc_maxbrowser',		'check_int');
	$valid_required &= check_and_set_required('max_extension',		'check_int');
	$valid_required &= check_and_set_required('bbc_maxrobot',		'check_int');
	$valid_required &= check_and_set_required('bbc_maxpage',		'check_int');
	$valid_required &= check_and_set_required('bbc_maxorigin',		'check_int');
	$valid_required &= check_and_set_required('bbc_general_align_style');
	$valid_required &= check_and_set_required('bbc_title_size',		'check_int');
	$valid_required &= check_and_set_required('bbc_subtitle_size',	'check_int');
	$valid_required &= check_and_set_required('bbc_text_size',		'check_int');

	if (!$valid_required)
		sapp_set_warning(msg('not_all_required_parameters_are_correctly_specifyed'));

	/*****************************
	 *
	 *	Optional parameters
	 *
	 *****************************/
	$valid_optional &= check_and_set_optional('bbc_ignoreip');
	$valid_optional &= check_and_set_optional('bbc_stat_field_id');
	$valid_optional &= check_and_set_optional('bbc_stat_field_time');
	$valid_optional &= check_and_set_optional('bbc_stat_field_visits');
	$valid_optional &= check_and_set_optional('bbc_stat_field_ext');
	$valid_optional &= check_and_set_optional('bbc_stat_field_dns');
	$valid_optional &= check_and_set_optional('bbc_stat_field_refer');
	$valid_optional &= check_and_set_optional('bbc_stat_field_os');
	$valid_optional &= check_and_set_optional('bbc_stat_field_browser');
	
	$valid_optional &= check_and_set_optional('bbc_stat_field_ip');
	$valid_optional &= check_and_set_optional('bbc_stat_field_page');
	$valid_optional &= check_and_set_optional('bbc_stat_field_query');

	if (!$valid_optional)
		sapp_set_warning(msg('optional_parameters_are_wrong'));

	if (!$valid_required || !$valid_optional) {
		sapp_set_error(msg('some_parameters_are_wrong'));
		// return the current step number
		return 1;
	}

	// set application URL
	sapp_set_param('application_url', sapp_get_param('install_prefix'));

	// return the next step number
	return 2;
}
?>